Index: vfs/gnu/ext2fs/ext2_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/gnu/ext2fs/ext2_vnops.c,v
retrieving revision 1.9
diff -u -r1.9 ext2_vnops.c
--- vfs/gnu/ext2fs/ext2_vnops.c	23 Sep 2003 05:03:52 -0000	1.9
+++ vfs/gnu/ext2fs/ext2_vnops.c	22 Feb 2004 05:54:54 -0000
@@ -352,7 +352,7 @@
 		error = EXDEV;
 		goto out2;
 	}
-	if (tdvp != vp && (error = vn_lock(vp, LK_EXCLUSIVE, td))) {
+	if (tdvp != vp && (error = vn_lock(vp, NULL, LK_EXCLUSIVE, td))) {
 		goto out2;
 	}
 	ip = VTOI(vp);
@@ -375,7 +375,7 @@
 	}
 out1:
 	if (tdvp != vp)
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 out2:
 	return (error);
 }
@@ -447,18 +447,18 @@
 		goto abortit;
 	}
 
-	if ((error = vn_lock(fvp, LK_EXCLUSIVE, td)) != 0)
+	if ((error = vn_lock(fvp, NULL, LK_EXCLUSIVE, td)) != 0)
 		goto abortit;
 	dp = VTOI(fdvp);
 	ip = VTOI(fvp);
  	if (ip->i_nlink >= LINK_MAX) {
- 		VOP_UNLOCK(fvp, 0, td);
+ 		VOP_UNLOCK(fvp, NULL, 0, td);
  		error = EMLINK;
  		goto abortit;
  	}
 	if ((ip->i_flags & (NOUNLINK | IMMUTABLE | APPEND))
 	    || (dp->i_flags & APPEND)) {
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		error = EPERM;
 		goto abortit;
 	}
@@ -469,7 +469,7 @@
 		if ((fcnp->cn_namelen == 1 && fcnp->cn_nameptr[0] == '.') ||
 		    dp == ip || (fcnp->cn_flags | tcnp->cn_flags) & CNP_ISDOTDOT ||
 		    (ip->i_flag & IN_RENAME)) {
-			VOP_UNLOCK(fvp, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			error = EINVAL;
 			goto abortit;
 		}
@@ -497,7 +497,7 @@
 	ip->i_nlink++;
 	ip->i_flag |= IN_CHANGE;
 	if ((error = UFS_UPDATE(fvp, 1)) != 0) {
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		goto bad;
 	}
 
@@ -512,7 +512,7 @@
 	 * call to checkpath().
 	 */
 	error = VOP_ACCESS(fvp, VWRITE, tcnp->cn_cred, tcnp->cn_td);
-	VOP_UNLOCK(fvp, 0, td);
+	VOP_UNLOCK(fvp, NULL, 0, td);
 	if (oldparent != dp->i_number)
 		newparent = dp->i_number;
 	if (doingdirectory && newparent) {
@@ -735,7 +735,7 @@
 out:
 	if (doingdirectory)
 		ip->i_flag &= ~IN_RENAME;
-	if (vn_lock(fvp, LK_EXCLUSIVE, td) == 0) {
+	if (vn_lock(fvp, NULL, LK_EXCLUSIVE, td) == 0) {
 		ip->i_nlink--;
 		ip->i_flag |= IN_CHANGE;
 		ip->i_flag &= ~IN_RENAME;
@@ -965,7 +965,7 @@
 	dp->i_nlink--;
 	dp->i_flag |= IN_CHANGE;
 	cache_purge(dvp);
-	VOP_UNLOCK(dvp, 0, td);
+	VOP_UNLOCK(dvp, NULL, 0, td);
 	/*
 	 * Truncate inode.  The only stuff left
 	 * in the directory is "." and "..".  The
@@ -980,7 +980,7 @@
 	ip->i_nlink -= 2;
 	error = UFS_TRUNCATE(vp, (off_t)0, IO_SYNC, cnp->cn_cred, td);
 	cache_purge(ITOV(ip));
-	vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 out:
 	return (error);
 }
Index: vfs/gnu/ext2fs/fs.h
===================================================================
RCS file: /cvs/src/sys/vfs/gnu/ext2fs/fs.h,v
retrieving revision 1.3
diff -u -r1.3 fs.h
--- vfs/gnu/ext2fs/fs.h	26 Jun 2003 20:27:51 -0000	1.3
+++ vfs/gnu/ext2fs/fs.h	22 Feb 2004 05:55:02 -0000
@@ -154,8 +154,8 @@
  * I think I'll try a VOP_LOCK/VOP_UNLOCK on the device vnode
  */
 #define  DEVVP(inode)		(VFSTOUFS(ITOV(inode)->v_mount)->um_devvp)
-#define  lock_super(devvp)   	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, curthread)
-#define  unlock_super(devvp) 	VOP_UNLOCK(devvp, 0, curthread)
+#define  lock_super(devvp)   	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, curthread)
+#define  unlock_super(devvp) 	VOP_UNLOCK(devvp, NULL, 0, curthread)
 
 /*
  * To lock a buffer, set the B_LOCKED flag and then brelse() it. To unlock,
Index: vfs/hpfs/hpfs.h
===================================================================
RCS file: /cvs/src/sys/vfs/hpfs/hpfs.h,v
retrieving revision 1.9
diff -u -r1.9 hpfs.h
--- vfs/hpfs/hpfs.h	5 Feb 2004 21:03:37 -0000	1.9
+++ vfs/hpfs/hpfs.h	22 Feb 2004 06:13:49 -0000
@@ -399,10 +399,10 @@
 #define	LOCKMGR(a, b, c, d)	lockmgr((a), (b), (c))
 #else  /* defined(__DragonFly__) */
 #define HASHINIT(a, b, c, d)	hashinit((a), (b), (d))
-#define VOP__LOCK(a, b, c)	VOP_LOCK((a), (b), (c))
-#define VOP__UNLOCK(a, b, c)	VOP_UNLOCK((a), (b), (c))
-#define VGET(a, b, c)		vget((a), (b), (c))
-#define VN_LOCK(a, b, c)	vn_lock((a), (b), (c))
+#define VOP__LOCK(a, b, c)	VOP_LOCK((a), NULL, (b), (c))
+#define VOP__UNLOCK(a, b, c)	VOP_UNLOCK((a), NULL, (b), (c))
+#define VGET(a, b, c)		vget((a), NULL, (b), (c))
+#define VN_LOCK(a, b, c)	vn_lock((a), NULL, (b), (c))
 #define	LOCKMGR(a, b, c, d)	lockmgr((a), (b), (c), (d))
 #endif
 
Index: vfs/hpfs/hpfs_hash.c
===================================================================
RCS file: /cvs/src/sys/vfs/hpfs/hpfs_hash.c,v
retrieving revision 1.9
diff -u -r1.9 hpfs_hash.c
--- vfs/hpfs/hpfs_hash.c	19 Oct 2003 21:24:55 -0000	1.9
+++ vfs/hpfs/hpfs_hash.c	22 Feb 2004 20:57:06 -0000
@@ -69,7 +69,7 @@
 	lockinit (&hpfs_hphash_lock, 0, "hpfs_hphashlock", 0, 0);
 	hpfs_hphashtbl = HASHINIT(desiredvnodes, M_HPFSHASH, M_WAITOK,
 	    &hpfs_hphash);
-	lwkt_inittoken(&hpfs_hphash_token);
+	lwkt_token_init(&hpfs_hphash_token);
 }
 
 /*
@@ -78,11 +78,12 @@
 int
 hpfs_hphash_uninit(struct vfsconf *vfc)
 {
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&hpfs_hphash_token);
+	lwkt_gettoken(&ilock, &hpfs_hphash_token);
 	if (hpfs_hphashtbl)
 		free(hpfs_hphashtbl, M_HPFSHASH);
-	lwkt_reltoken(&hpfs_hphash_token);
+	lwkt_reltoken(&ilock);
 
 	return 0;
 }
@@ -97,12 +98,14 @@
 	lsn_t ino;
 {
 	struct hpfsnode *hp;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&hpfs_hphash_token);
-	for (hp = HPNOHASH(dev, ino)->lh_first; hp; hp = hp->h_hash.le_next)
+	lwkt_gettoken(&ilock, &hpfs_hphash_token);
+	for (hp = HPNOHASH(dev, ino)->lh_first; hp; hp = hp->h_hash.le_next) {
 		if (ino == hp->h_no && dev == hp->h_dev)
 			break;
-	lwkt_reltoken(&hpfs_hphash_token);
+	}
+	lwkt_reltoken(&ilock);
 
 	return (hp);
 }
@@ -114,30 +117,40 @@
 	struct thread *td;
 {
 	struct hpfsnode *hp;
+	lwkt_tokref ilock;
+	lwkt_tokref vlock;
 	struct vnode *vp;
-	int gen;
 
-	gen = lwkt_gettoken(&hpfs_hphash_token);
+	lwkt_gettoken(&ilock, &hpfs_hphash_token);
 loop:
 	for (hp = HPNOHASH(dev, ino)->lh_first; hp; hp = hp->h_hash.le_next) {
-		if (ino == hp->h_no && dev == hp->h_dev) {
-			vp = HPTOV(hp);
-			lwkt_gettoken (&vp->v_interlock);
-			if (lwkt_gentoken(&hpfs_hphash_token, &gen))
-				goto loop;
-			if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-				gen = lwkt_regettoken(&hpfs_hphash_token);
-				goto loop;
-			}
-			if (lwkt_reltoken(&hpfs_hphash_token) != gen) {
-				vput(vp);
-				gen = lwkt_gettoken(&hpfs_hphash_token);
-				goto loop;
-			}
-			return (vp);
+		if (ino != hp->h_no || dev != hp->h_dev)
+			continue;
+		vp = HPTOV(hp);
+		lwkt_gettoken (&vlock, vp->v_interlock);
+
+		/*
+		 * We must check to see if the inode has been ripped
+		 * out from under us after blocking.
+		 */
+		for (hp = HPNOHASH(dev, ino)->lh_first; hp; hp = hp->h_hash.le_next) {
+			if (ino == hp->h_no && dev == hp->h_dev)
+				break;
+		}
+		if (hp == NULL || vp != HPTOV(hp)) {
+			lwkt_reltoken(&vlock);
+			goto loop;
 		}
+
+		/*
+		 * Or if the vget fails (due to a race)
+		 */
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td))
+			goto loop;
+		lwkt_reltoken(&ilock);
+		return (vp);
 	}
-	lwkt_reltoken(&hpfs_hphash_token);
+	lwkt_reltoken(&ilock);
 	return (NULLVP);
 }
 
@@ -149,12 +162,13 @@
 	struct hpfsnode *hp;
 {
 	struct hphashhead *hpp;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&hpfs_hphash_token);
+	lwkt_gettoken(&ilock, &hpfs_hphash_token);
 	hpp = HPNOHASH(hp->h_dev, hp->h_no);
 	hp->h_flag |= H_HASHED;
 	LIST_INSERT_HEAD(hpp, hp, h_hash);
-	lwkt_reltoken(&hpfs_hphash_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -164,7 +178,9 @@
 hpfs_hphashrem(hp)
 	struct hpfsnode *hp;
 {
-	lwkt_gettoken(&hpfs_hphash_token);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &hpfs_hphash_token);
 	if (hp->h_flag & H_HASHED) {
 		hp->h_flag &= ~H_HASHED;
 		LIST_REMOVE(hp, h_hash);
@@ -173,5 +189,5 @@
 		hp->h_hash.le_prev = NULL;
 #endif
 	}
-	lwkt_reltoken(&hpfs_hphash_token);
+	lwkt_reltoken(&ilock);
 }
Index: vfs/hpfs/hpfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/hpfs/hpfs_vfsops.c,v
retrieving revision 1.12
diff -u -r1.12 hpfs_vfsops.c
--- vfs/hpfs/hpfs_vfsops.c	5 Feb 2004 21:03:37 -0000	1.12
+++ vfs/hpfs/hpfs_vfsops.c	22 Feb 2004 07:20:18 -0000
@@ -668,7 +668,7 @@
 	if (ino == (ino_t)hpmp->hpm_su.su_rootfno) 
 		vp->v_flag |= VROOT;
 
-	lwkt_inittoken(&hp->h_interlock);
+	lwkt_token_init(&hp->h_interlock);
 	lockinit(&hp->h_lock, 0, "hpnode", VLKTIMEOUT, 0);
 
 	hp->h_flag = H_INVAL;
Index: vfs/isofs/cd9660/cd9660_lookup.c
===================================================================
RCS file: /cvs/src/sys/vfs/isofs/cd9660/cd9660_lookup.c,v
retrieving revision 1.8
diff -u -r1.8 cd9660_lookup.c
--- vfs/isofs/cd9660/cd9660_lookup.c	9 Oct 2003 22:27:24 -0000	1.8
+++ vfs/isofs/cd9660/cd9660_lookup.c	22 Feb 2004 05:57:18 -0000
@@ -352,16 +352,16 @@
 	 * it's a relocated directory.
 	 */
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(pdp, 0, td);	/* race to get the inode */
+		VOP_UNLOCK(pdp, NULL, 0, td);	/* race to get the inode */
 		error = cd9660_vget_internal(vdp->v_mount, dp->i_ino, &tdp,
 					     dp->i_ino != ino, ep);
 		brelse(bp);
 		if (error) {
-			vn_lock(pdp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(pdp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			return (error);
 		}
 		if (lockparent && (flags & CNP_ISLASTCN)) {
-			if ((error = vn_lock(pdp, LK_EXCLUSIVE, td)) != 0) {
+			if ((error = vn_lock(pdp, NULL, LK_EXCLUSIVE, td)) != 0) {
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 				vput(tdp);
 				return (error);
@@ -381,7 +381,7 @@
 			return (error);
 		if (!lockparent || !(flags & CNP_ISLASTCN)) {
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
-			VOP_UNLOCK(pdp, 0, td);
+			VOP_UNLOCK(pdp, NULL, 0, td);
 		}
 		*vpp = tdp;
 	}
Index: vfs/isofs/cd9660/cd9660_node.c
===================================================================
RCS file: /cvs/src/sys/vfs/isofs/cd9660/cd9660_node.c,v
retrieving revision 1.8
diff -u -r1.8 cd9660_node.c
--- vfs/isofs/cd9660/cd9660_node.c	18 Oct 2003 20:15:06 -0000	1.8
+++ vfs/isofs/cd9660/cd9660_node.c	22 Feb 2004 21:37:24 -0000
@@ -75,7 +75,7 @@
 {
 
 	isohashtbl = hashinit(desiredvnodes, M_ISOFSMNT, &isohash);
-	lwkt_inittoken(&cd9660_ihash_token);
+	lwkt_token_init(&cd9660_ihash_token);
 	return (0);
 }
 
@@ -101,32 +101,35 @@
 {
 	struct thread *td = curthread;		/* XXX */
 	struct iso_node *ip;
+	lwkt_tokref ilock;
+	lwkt_tokref vlock;
 	struct vnode *vp;
-	int gen;
 
-	gen = lwkt_gettoken(&cd9660_ihash_token);
+	lwkt_gettoken(&ilock, &cd9660_ihash_token);
 loop:
 	for (ip = isohashtbl[INOHASH(dev, inum)]; ip; ip = ip->i_next) {
-		if (inum == ip->i_number && dev == ip->i_dev) {
-			vp = ITOV(ip);
-			lwkt_gettoken(&vp->v_interlock); /* YYY */
-			if (lwkt_gentoken(&cd9660_ihash_token, &gen) != 0) {
-				lwkt_reltoken(&vp->v_interlock);
-				goto loop;
-			}
-			if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-				lwkt_gentoken(&cd9660_ihash_token, &gen);
-				goto loop;
-			}
-			if (lwkt_reltoken(&cd9660_ihash_token) != gen) {
-				vput(vp);
-				gen = lwkt_gettoken(&cd9660_ihash_token);
-				goto loop;
-			}
-			return (vp);
+		if (inum != ip->i_number || dev != ip->i_dev)
+			continue;
+		vp = ITOV(ip);
+		lwkt_gettoken(&vlock, vp->v_interlock);
+		/*
+		 * We must check to see if the inode has been ripped
+		 * out from under us after blocking.
+		 */   
+		for (ip = isohashtbl[INOHASH(dev, inum)]; ip; ip = ip->i_next) {
+			if (inum == ip->i_number && dev == ip->i_dev)
+				break;
 		}
+		if (ip == NULL || ITOV(ip) != vp) {
+			lwkt_reltoken(&vlock);
+			goto loop;
+		}
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td))
+			goto loop;
+		lwkt_reltoken(&ilock);
+		return (vp);
 	}
-	lwkt_reltoken(&cd9660_ihash_token);
+	lwkt_reltoken(&ilock);
 	return (NULL);
 }
 
@@ -138,15 +141,16 @@
 {
 	struct thread *td = curthread;	/* XXX */
 	struct iso_node **ipp, *iq;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&cd9660_ihash_token);
+	lwkt_gettoken(&ilock, &cd9660_ihash_token);
 	ipp = &isohashtbl[INOHASH(ip->i_dev, ip->i_number)];
 	if ((iq = *ipp) != NULL)
 		iq->i_prev = &ip->i_next;
 	ip->i_next = iq;
 	ip->i_prev = ipp;
 	*ipp = ip;
-	lwkt_reltoken(&cd9660_ihash_token);
+	lwkt_reltoken(&ilock);
 
 	lockmgr(&ip->i_lock, LK_EXCLUSIVE, NULL, td);
 }
@@ -159,8 +163,9 @@
 	struct iso_node *ip;
 {
 	struct iso_node *iq;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&cd9660_ihash_token);
+	lwkt_gettoken(&ilock, &cd9660_ihash_token);
 	if ((iq = ip->i_next) != NULL)
 		iq->i_prev = ip->i_prev;
 	*ip->i_prev = iq;
@@ -168,7 +173,7 @@
 	ip->i_next = NULL;
 	ip->i_prev = NULL;
 #endif
-	lwkt_reltoken(&cd9660_ihash_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -191,7 +196,7 @@
 		vprint("cd9660_inactive: pushing active", vp);
 
 	ip->i_flag = 0;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	/*
 	 * If we are done with the inode, reclaim it
 	 * so that it can be reused immediately.
Index: vfs/isofs/cd9660/cd9660_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/isofs/cd9660/cd9660_vfsops.c,v
retrieving revision 1.11
diff -u -r1.11 cd9660_vfsops.c
--- vfs/isofs/cd9660/cd9660_vfsops.c	23 Sep 2003 05:03:52 -0000	1.11
+++ vfs/isofs/cd9660/cd9660_vfsops.c	22 Feb 2004 05:57:25 -0000
@@ -150,9 +150,9 @@
 	}
 	args.flags = ISOFSMNT_ROOT;
 
-	vn_lock(rootvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(rootvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(rootvp, FREAD, FSCRED, td);
-	VOP_UNLOCK(rootvp, 0, td);
+	VOP_UNLOCK(rootvp, NULL, 0, td);
 	if (error)
 		return (error);
 
@@ -230,7 +230,7 @@
 	 * or has superuser abilities
 	 */
 	accessmode = VREAD;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_ACCESS(devvp, accessmode, td->td_proc->p_ucred, td);
 	if (error) 
 		error = suser(td);
@@ -238,7 +238,7 @@
 		vput(devvp);
 		return (error);
 	}
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 
 	if ((mp->mnt_flag & MNT_UPDATE) == 0) {
 		error = iso_mountfs(devvp, mp, td, &args);
@@ -305,9 +305,9 @@
 	if ((error = vinvalbuf(devvp, V_SAVE, td, 0, 0)))
 		return (error);
 
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(devvp, FREAD, FSCRED, td);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return error;
 	if (devvp->v_rdev->si_iosize_max != 0)
Index: vfs/mfs/mfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/mfs/mfs_vnops.c,v
retrieving revision 1.10
diff -u -r1.10 mfs_vnops.c
--- vfs/mfs/mfs_vnops.c	20 Aug 2003 09:56:32 -0000	1.10
+++ vfs/mfs/mfs_vnops.c	22 Feb 2004 05:39:33 -0000
@@ -374,7 +374,7 @@
 	if (bufq_first(&mfsp->buf_queue) != NULL)
 		panic("mfs_inactive: not inactive (next buffer %p)",
 			bufq_first(&mfsp->buf_queue));
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
Index: vfs/msdosfs/msdosfs_denode.c
===================================================================
RCS file: /cvs/src/sys/vfs/msdosfs/msdosfs_denode.c,v
retrieving revision 1.9
diff -u -r1.9 msdosfs_denode.c
--- vfs/msdosfs/msdosfs_denode.c	18 Oct 2003 20:15:08 -0000	1.9
+++ vfs/msdosfs/msdosfs_denode.c	22 Feb 2004 21:37:37 -0000
@@ -104,7 +104,7 @@
 	struct vfsconf *vfsp;
 {
 	dehashtbl = hashinit(desiredvnodes/2, M_MSDOSFSMNT, &dehash);
-	lwkt_inittoken(&dehash_token);
+	lwkt_token_init(&dehash_token);
 	return (0);
 }
 
@@ -126,35 +126,43 @@
 {
 	struct thread *td = curthread;	/* XXX */
 	struct denode *dep;
+	lwkt_tokref ilock;
+	lwkt_tokref vlock;
 	struct vnode *vp;
-	int gen;
 
-	gen = lwkt_gettoken(&dehash_token);
+	lwkt_gettoken(&ilock, &dehash_token);
 loop:
 	for (dep = DEHASH(dev, dirclust, diroff); dep; dep = dep->de_next) {
-		if (dirclust == dep->de_dirclust
-		    && diroff == dep->de_diroffset
-		    && dev == dep->de_dev
-		    && dep->de_refcnt != 0) {
-			vp = DETOV(dep);
-			lwkt_gettoken(&vp->v_interlock);
-			if (lwkt_gentoken(&dehash_token, &gen) != 0) {
-				lwkt_reltoken(&vp->v_interlock);
-				goto loop;
-			}
-			if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-				lwkt_gentoken(&dehash_token, &gen);
-				goto loop;
-			}
-			if (lwkt_reltoken(&dehash_token) != gen) {
-				vput(vp);
-				gen = lwkt_gettoken(&dehash_token);
-				goto loop;
+		if (dirclust != dep->de_dirclust
+		    || diroff != dep->de_diroffset
+		    || dev != dep->de_dev
+		    || dep->de_refcnt == 0) {
+			continue;
+		}
+		vp = DETOV(dep);
+		lwkt_gettoken(&vlock, vp->v_interlock);
+		/*
+		 * We must check to see if the inode has been ripped
+		 * out from under us after blocking.
+		 */
+		for (dep = DEHASH(dev, dirclust, diroff); dep; dep = dep->de_next) {
+			if (dirclust == dep->de_dirclust
+			    && diroff == dep->de_diroffset
+			    && dev == dep->de_dev
+			    && dep->de_refcnt != 0) {
+				break;
 			}
-			return (dep);
 		}
+		if (dep == NULL || DETOV(dep) != vp) {
+			lwkt_reltoken(&vlock);
+			goto loop;
+		}
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td))
+			goto loop;
+		lwkt_reltoken(&ilock);
+		return (dep);
 	}
-	lwkt_reltoken(&dehash_token);
+	lwkt_reltoken(&ilock);
 	return (NULL);
 }
 
@@ -163,8 +171,9 @@
 	struct denode *dep;
 {
 	struct denode **depp, *deq;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&dehash_token);
+	lwkt_gettoken(&ilock, &dehash_token);
 	depp = &DEHASH(dep->de_dev, dep->de_dirclust, dep->de_diroffset);
 	deq = *depp;
 	if (deq)
@@ -172,7 +181,7 @@
 	dep->de_next = deq;
 	dep->de_prev = depp;
 	*depp = dep;
-	lwkt_reltoken(&dehash_token);
+	lwkt_reltoken(&ilock);
 }
 
 static void
@@ -180,8 +189,9 @@
 	struct denode *dep;
 {
 	struct denode *deq;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&dehash_token);
+	lwkt_gettoken(&ilock, &dehash_token);
 	deq = dep->de_next;
 	if (deq)
 		deq->de_prev = dep->de_prev;
@@ -190,7 +200,7 @@
 	dep->de_next = NULL;
 	dep->de_prev = NULL;
 #endif
-	lwkt_reltoken(&dehash_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -723,7 +733,7 @@
 	deupdat(dep, 0);
 
 out:
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 	/*
 	 * If we are done with the denode, reclaim it
 	 * so that it can be reused immediately.
Index: vfs/msdosfs/msdosfs_lookup.c
===================================================================
RCS file: /cvs/src/sys/vfs/msdosfs/msdosfs_lookup.c,v
retrieving revision 1.7
diff -u -r1.7 msdosfs_lookup.c
--- vfs/msdosfs/msdosfs_lookup.c	9 Oct 2003 22:27:26 -0000	1.7
+++ vfs/msdosfs/msdosfs_lookup.c	22 Feb 2004 05:57:31 -0000
@@ -366,7 +366,7 @@
 		 */
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (EJUSTRETURN);
@@ -457,7 +457,7 @@
 			return (error);
 		*vpp = DETOV(tdp);
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (0);
@@ -490,7 +490,7 @@
 		*vpp = DETOV(tdp);
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (0);
@@ -517,16 +517,16 @@
 	 */
 	pdp = vdp;
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(pdp, 0, td);
+		VOP_UNLOCK(pdp, NULL, 0, td);
 		cnp->cn_flags |= CNP_PDIRUNLOCK;
 		error = deget(pmp, cluster, blkoff,  &tdp);
 		if (error) {
-			vn_lock(pdp, LK_EXCLUSIVE | LK_RETRY, td); 
+			vn_lock(pdp, NULL, LK_EXCLUSIVE | LK_RETRY, td); 
 			cnp->cn_flags &= ~CNP_PDIRUNLOCK;
 			return (error);
 		}
 		if (lockparent && (flags & CNP_ISLASTCN)) {
-			error = vn_lock(pdp, LK_EXCLUSIVE, td);
+			error = vn_lock(pdp, NULL, LK_EXCLUSIVE, td);
 			if (error) {
 				vput(DETOV(tdp));
 				return (error);
@@ -541,7 +541,7 @@
 		if ((error = deget(pmp, cluster, blkoff, &tdp)) != 0)
 			return (error);
 		if (!lockparent || !(flags & CNP_ISLASTCN)) {
-			VOP_UNLOCK(pdp, 0, td);
+			VOP_UNLOCK(pdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		*vpp = DETOV(tdp);
Index: vfs/msdosfs/msdosfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/msdosfs/msdosfs_vfsops.c,v
retrieving revision 1.10
diff -u -r1.10 msdosfs_vfsops.c
--- vfs/msdosfs/msdosfs_vfsops.c	5 Feb 2004 21:03:37 -0000	1.10
+++ vfs/msdosfs/msdosfs_vfsops.c	22 Feb 2004 22:07:38 -0000
@@ -271,14 +271,14 @@
 			 */
 			if (p->p_ucred->cr_uid != 0) {
 				devvp = pmp->pm_devvp;
-				vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+				vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 				error = VOP_ACCESS(devvp, VREAD | VWRITE,
 						   p->p_ucred, td);
 				if (error) {
-					VOP_UNLOCK(devvp, 0, td);
+					VOP_UNLOCK(devvp, NULL, 0, td);
 					return (error);
 				}
-				VOP_UNLOCK(devvp, 0, td);
+				VOP_UNLOCK(devvp, NULL, 0, td);
 			}
 			pmp->pm_flags &= ~MSDOSFSMNT_RONLY;
 		}
@@ -320,13 +320,13 @@
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		error = VOP_ACCESS(devvp, accessmode, p->p_ucred, td);
 		if (error) {
 			vput(devvp);
 			return (error);
 		}
-		VOP_UNLOCK(devvp, 0, td);
+		VOP_UNLOCK(devvp, NULL, 0, td);
 	}
 	if ((mp->mnt_flag & MNT_UPDATE) == 0) {
 		error = mountmsdosfs(devvp, mp, td, &args);
@@ -395,16 +395,16 @@
 		return (error);
 	if (vcount(devvp) > 1 && devvp != rootvp)
 		return (EBUSY);
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = vinvalbuf(devvp, V_SAVE, td, 0, 0);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return (error);
 
 	ronly = (mp->mnt_flag & MNT_RDONLY) != 0;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(devvp, ronly ? FREAD : FREAD|FWRITE, FSCRED, td);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return (error);
 
@@ -846,17 +846,25 @@
 	return (0);
 }
 
+struct scaninfo {
+	int rescan;
+	int allerror;
+	int waitfor;
+	thread_t td;
+};
+
+static int msdosfs_sync_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data);
+
 static int
 msdosfs_sync(mp, waitfor, td)
 	struct mount *mp;
 	int waitfor;
 	struct thread *td;
 {
-	struct vnode *vp, *nvp;
-	struct denode *dep;
 	struct msdosfsmount *pmp = VFSTOMSDOSFS(mp);
-	int error, allerror = 0;
-	int gen;
+	struct scaninfo scaninfo;
+	int error;
 
 	/*
 	 * If we ever switch to not updating all of the fats all the time,
@@ -871,63 +879,53 @@
 	}
 	/*
 	 * Write back each (modified) denode.
-	 *
-	 * YYY gen number handling needs more work.
 	 */
-	gen = lwkt_gettoken(&mntvnode_token);
-loop:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nvp) {
-		lwkt_gettoken(&vp->v_interlock);
-		/*
-		 * If the vnode that we are about to sync is no longer
-		 * associated with this mount point, start over.  If
-		 * we lost the mntvnode token, start over.
-		 */
-		if (vp->v_mount != mp) {
-			lwkt_reltoken(&vp->v_interlock);
-			goto loop;
-		}
-		if (lwkt_gentoken(&mntvnode_token, &gen) != 0) {
-			lwkt_reltoken(&vp->v_interlock);
-			goto loop;
-		}
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		dep = VTODE(vp);
-		if (vp->v_type == VNON ||
-		    ((dep->de_flag &
-		    (DE_ACCESS | DE_CREATE | DE_UPDATE | DE_MODIFIED)) == 0 &&
-		    (TAILQ_EMPTY(&vp->v_dirtyblkhd) || waitfor == MNT_LAZY))) {
-			lwkt_reltoken(&vp->v_interlock);
-			continue;
-		}
-		lwkt_reltoken(&mntvnode_token);
-		error = vget(vp, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, td);
-		if (error) {
-			lwkt_gettoken(&mntvnode_token);
-			if (error == ENOENT)
-				goto loop;
-			continue;
-		}
-		error = VOP_FSYNC(vp, waitfor, td);
-		if (error)
-			allerror = error;
-		VOP_UNLOCK(vp, 0, td);
-		vrele(vp);
-		lwkt_gettoken(&mntvnode_token);
+	scaninfo.allerror = 0;
+	scaninfo.rescan = 1;
+	scaninfo.td = td;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		vmntvnodescan(mp, NULL, msdosfs_sync_scan, &scaninfo);
 	}
-	lwkt_reltoken(&mntvnode_token);
 
 	/*
 	 * Flush filesystem control info.
 	 */
 	if (waitfor != MNT_LAZY) {
-		vn_lock(pmp->pm_devvp, LK_EXCLUSIVE | LK_RETRY, td);
-		error = VOP_FSYNC(pmp->pm_devvp, waitfor, td);
-		if (error)
-			allerror = error;
-		VOP_UNLOCK(pmp->pm_devvp, 0, td);
+		vn_lock(pmp->pm_devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
+		if ((error = VOP_FSYNC(pmp->pm_devvp, waitfor, td)) != 0)
+			scaninfo.allerror = error;
+		VOP_UNLOCK(pmp->pm_devvp, NULL, 0, td);
 	}
-	return (allerror);
+	return (scaninfo.allerror);
+}
+
+static int msdosfs_sync_scan(struct mount *mp, struct vnode *vp,
+		lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct denode *dep;
+	int error;
+
+	dep = VTODE(vp);
+	if (vp->v_type == VNON ||
+	    ((dep->de_flag &
+	    (DE_ACCESS | DE_CREATE | DE_UPDATE | DE_MODIFIED)) == 0 &&
+	    (TAILQ_EMPTY(&vp->v_dirtyblkhd) || info->waitfor == MNT_LAZY))) {
+		lwkt_reltoken(vlock);
+		return(0);
+	}
+	error = vget(vp, vlock, LK_EXCLUSIVE | LK_NOWAIT | LK_INTERLOCK, info->td);
+	if (error) {
+		if (error == ENOENT)
+			info->rescan = 1;
+		return(0);
+	}
+	if ((error = VOP_FSYNC(vp, info->waitfor, info->td)) != 0)
+		info->allerror = error;
+	VOP_UNLOCK(vp, NULL, 0, info->td);
+	vrele(vp);
+	return(0);
 }
 
 static int
Index: vfs/msdosfs/msdosfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/msdosfs/msdosfs_vnops.c,v
retrieving revision 1.12
diff -u -r1.12 msdosfs_vnops.c
--- vfs/msdosfs/msdosfs_vnops.c	23 Sep 2003 05:03:52 -0000	1.12
+++ vfs/msdosfs/msdosfs_vnops.c	22 Feb 2004 19:07:23 -0000
@@ -233,16 +233,16 @@
 	struct vnode *vp = ap->a_vp;
 	struct denode *dep = VTODE(vp);
 	struct timespec ts;
+	lwkt_tokref vlock;
 
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if (vp->v_usecount > 1) {
 		getnanotime(&ts);
-		lwkt_regettoken(&vp->v_interlock);
 		if (vp->v_usecount > 1) {
 			DETIMES(dep, &ts, &ts, &ts);
 		}
 	}
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 	return 0;
 }
 
@@ -1050,7 +1050,7 @@
 		goto abortit;
 	}
 
-	error = vn_lock(fvp, LK_EXCLUSIVE, td);
+	error = vn_lock(fvp, NULL, LK_EXCLUSIVE, td);
 	if (error)
 		goto abortit;
 	dp = VTODE(fdvp);
@@ -1071,7 +1071,7 @@
 		    (fcnp->cn_flags & CNP_ISDOTDOT) ||
 		    (tcnp->cn_flags & CNP_ISDOTDOT) ||
 		    (ip->de_flag & DE_RENAME)) {
-			VOP_UNLOCK(fvp, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			error = EINVAL;
 			goto abortit;
 		}
@@ -1102,7 +1102,7 @@
 	 * call to doscheckpath().
 	 */
 	error = VOP_ACCESS(fvp, VWRITE, tcnp->cn_cred, tcnp->cn_td);
-	VOP_UNLOCK(fvp, 0, td);
+	VOP_UNLOCK(fvp, NULL, 0, td);
 	if (VTODE(fdvp)->de_StartCluster != VTODE(tdvp)->de_StartCluster)
 		newparent = 1;
 	if (doingdirectory && newparent) {
@@ -1171,7 +1171,7 @@
 	if ((fcnp->cn_flags & CNP_SAVESTART) == 0)
 		panic("msdosfs_rename: lost from startdir");
 	if (!newparent)
-		VOP_UNLOCK(tdvp, 0, td);
+		VOP_UNLOCK(tdvp, NULL, 0, td);
 	if (relookup(fdvp, &fvp, fcnp) == 0)
 		vrele(fdvp);
 	if (fvp == NULL) {
@@ -1182,7 +1182,7 @@
 			panic("rename: lost dir entry");
 		vrele(ap->a_fvp);
 		if (newparent)
-			VOP_UNLOCK(tdvp, 0, td);
+			VOP_UNLOCK(tdvp, NULL, 0, td);
 		vrele(tdvp);
 		return 0;
 	}
@@ -1202,9 +1202,9 @@
 		if (doingdirectory)
 			panic("rename: lost dir entry");
 		vrele(ap->a_fvp);
-		VOP_UNLOCK(fvp, 0, td);
+		VOP_UNLOCK(fvp, NULL, 0, td);
 		if (newparent)
-			VOP_UNLOCK(fdvp, 0, td);
+			VOP_UNLOCK(fdvp, NULL, 0, td);
 		xp = NULL;
 	} else {
 		vrele(fvp);
@@ -1226,8 +1226,8 @@
 		if (error) {
 			bcopy(oldname, ip->de_Name, 11);
 			if (newparent)
-				VOP_UNLOCK(fdvp, 0, td);
-			VOP_UNLOCK(fvp, 0, td);
+				VOP_UNLOCK(fdvp, NULL, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			goto bad;
 		}
 		ip->de_refcnt++;
@@ -1236,8 +1236,8 @@
 		if (error) {
 			/* XXX should really panic here, fs is corrupt */
 			if (newparent)
-				VOP_UNLOCK(fdvp, 0, td);
-			VOP_UNLOCK(fvp, 0, td);
+				VOP_UNLOCK(fdvp, NULL, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			goto bad;
 		}
 		if (!doingdirectory) {
@@ -1246,8 +1246,8 @@
 			if (error) {
 				/* XXX should really panic here, fs is corrupt */
 				if (newparent)
-					VOP_UNLOCK(fdvp, 0, td);
-				VOP_UNLOCK(fvp, 0, td);
+					VOP_UNLOCK(fdvp, NULL, 0, td);
+				VOP_UNLOCK(fvp, NULL, 0, td);
 				goto bad;
 			}
 			if (ip->de_dirclust == MSDOSFSROOT)
@@ -1257,7 +1257,7 @@
 		}
 		reinsert(ip);
 		if (newparent)
-			VOP_UNLOCK(fdvp, 0, td);
+			VOP_UNLOCK(fdvp, NULL, 0, td);
 	}
 
 	/*
@@ -1275,7 +1275,7 @@
 		if (error) {
 			/* XXX should really panic here, fs is corrupt */
 			brelse(bp);
-			VOP_UNLOCK(fvp, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			goto bad;
 		}
 		dotdotp = (struct direntry *)bp->b_data + 1;
@@ -1285,12 +1285,12 @@
 		error = bwrite(bp);
 		if (error) {
 			/* XXX should really panic here, fs is corrupt */
-			VOP_UNLOCK(fvp, 0, td);
+			VOP_UNLOCK(fvp, NULL, 0, td);
 			goto bad;
 		}
 	}
 
-	VOP_UNLOCK(fvp, 0, td);
+	VOP_UNLOCK(fvp, NULL, 0, td);
 bad:
 	if (xp)
 		vput(tvp);
@@ -1489,14 +1489,14 @@
 	 * the name cache.
 	 */
 	cache_purge(dvp);
-	VOP_UNLOCK(dvp, 0, td);
+	VOP_UNLOCK(dvp, NULL, 0, td);
 	/*
 	 * Truncate the directory that is being deleted.
 	 */
 	error = detrunc(ip, (u_long)0, IO_SYNC, td);
 	cache_purge(vp);
 
-	vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 out:
 	return (error);
 }
Index: vfs/nfs/nfs_node.c
===================================================================
RCS file: /cvs/src/sys/vfs/nfs/nfs_node.c,v
retrieving revision 1.8
diff -u -r1.8 nfs_node.c
--- vfs/nfs/nfs_node.c	10 Oct 2003 22:01:13 -0000	1.8
+++ vfs/nfs/nfs_node.c	22 Feb 2004 06:14:58 -0000
@@ -112,7 +112,7 @@
 		    bcmp((caddr_t)fhp, (caddr_t)np->n_fhp, fhsize))
 			continue;
 		vp = NFSTOV(np);
-		if (vget(vp, LK_EXCLUSIVE|LK_SLEEPFAIL, td))
+		if (vget(vp, NULL, LK_EXCLUSIVE|LK_SLEEPFAIL, td))
 			goto loop;
 		*npp = np;
 		return(0);
@@ -182,7 +182,7 @@
 	/*
 	 * Lock the new nfsnode.
 	 */
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	return (0);
 }
@@ -215,7 +215,7 @@
 		 */
 		if (ap->a_vp->v_usecount > 0)
 			(void) nfs_vinvalbuf(ap->a_vp, 0, ap->a_td, 1);
-		else if (vget(ap->a_vp, 0, ap->a_td))
+		else if (vget(ap->a_vp, NULL, 0, ap->a_td))
 			panic("nfs_inactive: lost vnode");
 		else {
 			(void) nfs_vinvalbuf(ap->a_vp, 0, ap->a_td, 1);
@@ -231,7 +231,7 @@
 	}
 	np->n_flag &= (NMODIFIED | NFLUSHINPROG | NFLUSHWANT | NQNFSEVICTED |
 		NQNFSNONCACHE | NQNFSWRITE);
-	VOP_UNLOCK(ap->a_vp, 0, ap->a_td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
